.486
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include Windows.inc
include Kernel32.inc
include Ole32.inc

includelib Kernel32.lib
includelib Ole32.lib

Unknown STRUCT
	QueryInterface			DWORD		?
	AddRef					DWORD		?
	Release					DWORD		?
Unknown ends

IShellLink STRUCT
	IUnknown				Unknown		<>

	GetPath					DWORD	?
	GetIDList 				DWORD	?
	SetIDList				DWORD	?
	GetDescription			DWORD	?
	SetDescription			DWORD	?
	GetWorkingDirectory		DWORD	?
	SetWorkingDirectory		DWORD	?
	GetArguments			DWORD	?
	SetArguments			DWORD	?
	GetHotkey				DWORD	?
	SetHotkey				DWORD	?
	GetShowCmd				DWORD	?
	SetShowCmd				DWORD	?
	GetIconLocation			DWORD	?
	SetIconLocation			DWORD	?
	SetRelativePath			DWORD	?
	Resolve					DWORD	?
	SetPath					DWORD	?
IShellLink ENDS

IPersistFile STRUCT
	IUnknown				Unknown		<>

	GetClassID				DWORD	?
	IsDirty					DWORD	?
	Load					DWORD	?
	Save					DWORD	?
	SaveCompleted			DWORD	?
	GetCurFile				DWORD	?
IPersistFile ENDS

.const

	sIID_IShellLink			textequ			<{0000214EEH, 00000H, 00000H,\
										{0C0H, 000H, 000H, 000H, 000H, 000H, 000H, 046H}}>

	sCLSID_ShellLink		textequ			<{000021401H, 00000H, 00000H,\
										{0C0H, 000H, 000H, 000H, 000H, 000H, 000H, 046H}}>

	sIID_IPersistFile		textequ			<{00000010bH, 00000H, 00000H,\
										{0C0H, 000H, 000H, 000H, 000H, 000H, 000H, 046H}}>

.data

	CLSID_ShellLink			GUID			sCLSID_ShellLink
	IID_IShellLink			GUID			sIID_IShellLink
	IID_IPersistFile		GUID			sIID_IPersistFile

.code

FindTarget proc lpLINKPATH:DWORD,lpbuffer:DWORD
	LOCAL psl				:DWORD
	LOCAL ppf				:DWORD
	LOCAL wsz[MAX_PATH]		:WORD

	; This procedure extracts the location (path) of the object referenced by a shortcut.
	; lpLINKPATH contains the full path of the lnk file, lpbuffer is a buffer of the size
	; MAX_PATH that recieves the resulting path of the referenced object. If lpLINKPATH and
	; lpbuffer point to the same buffer the link path will be replaced by the referenced
	; path. The procedure does not perform a size verification on the buffer so an exception
	; may occur if the buffer size is less than MAX_PATH.
	;
	; Requirements : CoInitialize must be called before calling this procedure
	; Libraries : ole32, Kernel32
	; Windows.inc must be included
	; OS Versions : NT 4.0, Windows 95,98,98SE,ME,2000,XP
	;
	; Returns -1 if there is no link or an error has occurred

	invoke CoCreateInstance,ADDR CLSID_ShellLink,NULL,CLSCTX_INPROC_SERVER,ADDR IID_IShellLink,ADDR psl
	.IF eax != S_OK
		mov eax,-1
		ret
	.endif

	lea eax,ppf
	push eax
	lea eax,IID_IPersistFile
	push eax
	push psl
	mov edi,psl
	mov edi,[edi]
	call [edi].IShellLink.IUnknown.QueryInterface
	.IF eax != S_OK
		push psl
		mov edi,psl
		mov edi,[edi]
		call [edi].IShellLink.IUnknown.Release
		ret
	.endif

	invoke MultiByteToWideChar,CP_ACP,NULL,lpLINKPATH,-1,ADDR wsz,MAX_PATH

	push STGM_READ
	lea eax,wsz
	push eax
	push ppf
	mov edi,ppf
	mov edi,[edi]
	call [edi].IPersistFile.Load
	.IF eax != S_OK
		push ppf
		mov edi,ppf
		mov edi,[edi]
		call [edi].IPersistFile.IUnknown.Release

		push psl
		mov edi,psl
		mov edi,[edi]
		call [edi].IShellLink.IUnknown.Release
		mov eax,-1
		ret
	.endif

	push NULL
	push NULL
	push MAX_PATH
	push lpbuffer
	push psl
	mov edi,psl
	mov edi,[edi]
	call [edi].IShellLink.GetPath
	.IF eax != NOERROR
		push ppf
		mov edi,ppf
		mov edi,[edi]
		call [edi].IPersistFile.IUnknown.Release

		push psl
		mov edi,psl
		mov edi,[edi]
		call [edi].IShellLink.IUnknown.Release
		mov eax,-1
		ret
	.ENDIF

	push ppf
	mov edi,ppf
	mov edi,[edi]
	call [edi].IPersistFile.IUnknown.Release

	push psl
	mov edi,psl
	mov edi,[edi]
	call [edi].IShellLink.IUnknown.Release

	xor eax,eax

	ret
FindTarget endp
END
